
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* This sort of behaviour is quick and nasty */

unsigned char zcodefile[256*1024];
unsigned char snapfile[49179];

int zlen;
int zxoff;
int lategame;

int main(int argc, char **argv)
{
	FILE *fp;

	lategame = 0;
	if (argc < 4)
	{
		fprintf(stderr,"Syntax: %s zcodefile snapfile outfile { L }\n",
			argv[0]);
		exit(1);
	}
	if (argc > 4 && argv[4][0] == 'L') lategame = 1;
	fp = fopen(argv[1], "rb");
	if (!fp) 
	{
		fprintf(stderr,"Can't open %s\n", argv[1]);
		exit(1);
	}
	zlen = fread(zcodefile, 1, 256*1024, fp);
	fclose(fp);

	for (zxoff = 0; zxoff < (zlen-4); zxoff++)
	{
		if (!memcmp(zcodefile + zxoff, "Achad", 5)) break; 
	} 
	if (zxoff >= (zlen-4))
	{
		fprintf(stderr, "Can't find the magic word 'Achad' in %s\n",
			argv[1]);
		exit(1);
	}

	fp = fopen(argv[2], "rb");
	if (fread(snapfile, 1, 49179, fp) < 49179)
	{
		fprintf(stderr,"Warning: %s is too short, and probably "
                               "not in .SNA format.", argv[2]); 
	}
	fclose(fp);
	memcpy(zcodefile + zxoff + 5, snapfile + 0x1c1b, 0xa400);

	zcodefile[zxoff + 0xa405] = 1;		/* Game loaded */
	zcodefile[zxoff + 0xa406] = lategame;	/* "late" game? */
/*	zcodefile[zxoff + 0xa407] = 1;		mono */
 	zcodefile[zxoff + 0xa408] = 1;		/* no graphics */

/* XXX Checksum the new zcode file! */

	fp = fopen(argv[3], "wb");
	if (!fp) 
	{
		fprintf(stderr, "Could not write %s\n", argv[3]);
		exit(1);
	}
	fwrite(zcodefile, 1, zlen, fp);
	fclose(fp);

	return 0;
}
